#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <omp.h>

int *copyArray(int const * oldArray, size_t size);
void sort(int *array,int n);
int getThreadPos(int n);
int nMember;
int nThread;

int main(int argc, char *argv[]) {
    time_t start, stop;
    if(argc != 3){
        fprintf(stderr, "Usage: bucketsort (jumlah elemen) (jumlah threads)\n");
        exit(1);
    }
    int i;
    int index = 0;
	int* member = (int*) malloc (sizeof (int) * nMember);
	int* bucketMember;
	int id, num = 0;
	int buckStat, done = 0;
    /* get input */
    nMember = atoi(argv[1]);
    nThread = atoi(argv[2]);
	
	
	//make random number
    for(i = 1; i<= nMember; i++){
		member[i]  = rand() % nMember;
	}
    time(&start);
	int* membersorted = (int*) malloc (sizeof (int) * nMember);
	# pragma omp parallel num_threads(nThread) \
    shared(member,index,membersorted,nMember,num) private(done,bucketMember,id,i,buckStat)        
    {
		bucketMember = (int*) malloc (sizeof(int) * nMember);        
		id = omp_get_thread_num();  
		for (i=0;i<nMember;i++) {
			if (getThreadPos(member[i])==id) {
				bucketMember[buckStat] = member[i];
				buckStat++;
				//printf("thread = %d, value = %d \n", id, member[i]);
			}
		}
		sort(bucketMember,buckStat);;
		while (!done) {
			#pragma omp critical    
			{
				if (index==id) {
					for (i=0;i<buckStat;i++) {
						membersorted[num]=bucketMember[i];
						num++;
					}
					index++;
					done = 1;
				}
			}   
		}
    }
    time(&stop);
    printf("bucketsort = %0.2f seconds \n", difftime(stop, start));
    time(&start);
    sort(member, nMember);
    time(&stop);
    printf("normal sort = %0.2f seconds \n", difftime(stop, start));	
}

int *copyArray(int const * oldArray, size_t size) {
   int * newArray = malloc(sizeof(int) * size);
   memcpy(newArray, oldArray, sizeof(int) * size);
   return newArray;
} 

int getThreadPos(int n){
	return (n * nThread / nMember);
}

void sort(int *array,int n){
    int d,c,t;
    for (c = 1 ; c <= n - 1; c++) {
        d = c;
        while ( d > 0 && array[d] < array[d-1]) {
            t          = array[d];
            array[d]   = array[d-1];
            array[d-1] = t;
            d--;
        }
    }
}

